<template>
  <v-data-table
    :headers="vehicleHeaders"
    :items="vehicleOrders"
    hide-default-footer
  >
    <template #item.order="{ index }">
      {{ withZeros({ id: index + 1, zeros: 2 }) }}
    </template>
    <template #item.clientOrder="{ item }">
      {{ hashId({ id: item.id }) }} - {{ item.client.businessName }}
    </template>
    <template #item.units="{ item }">
      {{ withZeros({ id: item.toSendUnits, zeros: 2 }) }}
    </template>
    <template #item.guide="{ item }">
      <v-btn
        outlined
        color="secondary"
        :loading="!!downloading[`${item.id}`]"
        @click="() => downloadGuide(item)"
      >
        <v-icon>mdi-cloud-download</v-icon>
      </v-btn>
    </template>
  </v-data-table>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import { __, indexBy, map, prop } from 'ramda';
import { hashId, withZeros } from '~/helpers/format/ids';
import { errorOptions } from '~/helpers/toast';

export default {
  name: 'VehicleDetailOrders',
  props: {
    vehicleId: {
      type: [Number, String],
      required: true,
    },
    orderIds: {
      type: Array,
      default: () => [],
    },
  },
  data: () => ({
    downloading: {},
    vehicleHeaders: [
      { text: 'Orden de entrega', align: 'center', sortable: false, value: 'order' },
      { text: 'Pedido - Cliente', align: 'start', sortable: false, value: 'clientOrder' },
      { text: 'Unidades (pallets)', align: 'center', sortable: false, value: 'units' },
      { text: 'Guías de remisión', align: 'start', sortable: false, value: 'guide' },
    ],
  }),
  computed: {
    ...mapState({
      orders: state => state.programming.dispatches.current.orders,
      vehicleOrders() {
        const indexed = indexBy(prop('id'), this.orders);
        return map(prop(__, indexed), this.orderIds);
      },
    }),
  },
  methods: {
    hashId,
    withZeros,
    ...mapActions({
      downloadReferralGuide: 'programming/dispatches/downloadReferralGuide',
    }),
    async downloadGuide({ id, client }) {
      this.downloading[`${id}`] = true;
      try {
        const fileUrl = await this.downloadReferralGuide({ vehicleId: this.vehicleId, orderId: id });
        window.open(fileUrl, '_blank');
      } catch (e) {
        this.$toast.error(`No se pudo descargar la guía de remisión para el cliente ${client.name}`, errorOptions);
      }
      this.downloading[`${id}`] = false;
    },
  },
};
</script>
